{
    "$graph": [
        {
            "class": "Workflow",
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/brandimg"
                },
                {
                    "type": "string",
                    "default": "",
                    "id": "#main/empty"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "record",
                            "fields": [
                                {
                                    "type": "string",
                                    "name": "#main/render/brandimg"
                                },
                                {
                                    "type": "string",
                                    "name": "#main/render/brandlink"
                                },
                                {
                                    "type": "File",
                                    "name": "#main/render/extra"
                                },
                                {
                                    "type": [
                                        "null",
                                        "string"
                                    ],
                                    "name": "#main/render/primtype"
                                },
                                {
                                    "type": [
                                        "null",
                                        {
                                            "type": "array",
                                            "items": "string"
                                        }
                                    ],
                                    "name": "#main/render/redirect"
                                },
                                {
                                    "type": [
                                        "null",
                                        {
                                            "type": "array",
                                            "items": "string"
                                        }
                                    ],
                                    "name": "#main/render/renderlist"
                                },
                                {
                                    "type": "File",
                                    "name": "#main/render/source"
                                },
                                {
                                    "type": "string",
                                    "name": "#main/render/target"
                                }
                            ]
                        }
                    },
                    "id": "#main/render"
                },
                {
                    "type": {
                        "type": "array",
                        "items": {
                            "type": "record",
                            "fields": [
                                {
                                    "type": "string",
                                    "name": "#main/schemas/context_target"
                                },
                                {
                                    "type": "string",
                                    "name": "#main/schemas/graph_target"
                                },
                                {
                                    "type": "string",
                                    "name": "#main/schemas/rdfs_target"
                                },
                                {
                                    "type": "File",
                                    "name": "#main/schemas/schema_in"
                                }
                            ]
                        }
                    },
                    "id": "#main/schemas"
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "hints": [
                {
                    "dockerPull": "commonworkflowlanguage/cwltool_module",
                    "class": "DockerRequirement"
                }
            ],
            "steps": [
                {
                    "scatter": [
                        "#main/docs/source",
                        "#main/docs/target",
                        "#main/docs/renderlist",
                        "#main/docs/redirect",
                        "#main/docs/brandlink",
                        "#main/docs/brand",
                        "#main/docs/primtype",
                        "#main/docs/extra"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "source": "#main/render",
                            "valueFrom": "$(self.brandimg)",
                            "id": "#main/docs/brand"
                        },
                        {
                            "source": "#main/render",
                            "valueFrom": "$(self.brandlink)",
                            "id": "#main/docs/brandlink"
                        },
                        {
                            "source": "#main/render",
                            "valueFrom": "$(self.extra)",
                            "id": "#main/docs/extra"
                        },
                        {
                            "source": "#main/render",
                            "valueFrom": "$(self.primtype)",
                            "id": "#main/docs/primtype"
                        },
                        {
                            "source": "#main/render",
                            "valueFrom": "$(self.redirect)",
                            "id": "#main/docs/redirect"
                        },
                        {
                            "source": "#main/render",
                            "valueFrom": "$(self.renderlist)",
                            "id": "#main/docs/renderlist"
                        },
                        {
                            "source": "#main/render",
                            "valueFrom": "$(self.source)",
                            "id": "#main/docs/source"
                        },
                        {
                            "source": "#main/render",
                            "valueFrom": "$(self.target)",
                            "id": "#main/docs/target"
                        }
                    ],
                    "out": [
                        "#main/docs/html",
                        "#main/docs/targetdir",
                        "#main/docs/extra_out"
                    ],
                    "run": "#makedoc.cwl",
                    "id": "#main/docs"
                },
                {
                    "in": [
                        {
                            "source": "#main/merge/dir",
                            "id": "#main/generate_report/inp"
                        }
                    ],
                    "out": [
                        "#main/generate_report/report"
                    ],
                    "run": "#linkchecker.cwl",
                    "id": "#main/generate_report"
                },
                {
                    "scatter": [
                        "#main/graph_inheritance/schema",
                        "#main/graph_inheritance/target_path"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "source": "#main/schemas",
                            "valueFrom": "$(self.schema_in)",
                            "id": "#main/graph_inheritance/schema"
                        },
                        {
                            "source": "#main/schemas",
                            "valueFrom": "$(self.graph_target)",
                            "id": "#main/graph_inheritance/target_path"
                        }
                    ],
                    "out": [
                        "#main/graph_inheritance/svg",
                        "#main/graph_inheritance/targetdir"
                    ],
                    "run": "#inheritance.cwl",
                    "id": "#main/graph_inheritance"
                },
                {
                    "scatter": [
                        "#main/make_context/schema",
                        "#main/make_context/target_path"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "source": "#main/schemas",
                            "valueFrom": "$(self.schema_in)",
                            "id": "#main/make_context/schema"
                        },
                        {
                            "source": "#main/schemas",
                            "valueFrom": "$(self.context_target)",
                            "id": "#main/make_context/target_path"
                        }
                    ],
                    "out": [
                        "#main/make_context/jsonld_context",
                        "#main/make_context/targetdir"
                    ],
                    "run": "#makecontext.cwl",
                    "id": "#main/make_context"
                },
                {
                    "scatter": [
                        "#main/make_rdfs/schema",
                        "#main/make_rdfs/target_path"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "source": "#main/schemas",
                            "valueFrom": "$(self.schema_in)",
                            "id": "#main/make_rdfs/schema"
                        },
                        {
                            "source": "#main/schemas",
                            "valueFrom": "$(self.rdfs_target)",
                            "id": "#main/make_rdfs/target_path"
                        }
                    ],
                    "out": [
                        "#main/make_rdfs/rdfs",
                        "#main/make_rdfs/targetdir"
                    ],
                    "run": "#makerdfs.cwl",
                    "id": "#main/make_rdfs"
                },
                {
                    "in": [
                        {
                            "source": [
                                "#main/docs/targetdir",
                                "#main/make_rdfs/targetdir",
                                "#main/make_context/targetdir",
                                "#main/empty",
                                "#main/docs/targetdir",
                                "#main/graph_inheritance/targetdir"
                            ],
                            "linkMerge": "merge_flattened",
                            "valueFrom": "$(self.slice(1))",
                            "id": "#main/merge/dirs"
                        },
                        {
                            "source": "#main/docs/html",
                            "valueFrom": "$(self[0])",
                            "id": "#main/merge/primary"
                        },
                        {
                            "source": [
                                "#main/docs/html",
                                "#main/make_rdfs/rdfs",
                                "#main/make_context/jsonld_context",
                                "#main/brandimg",
                                "#main/docs/extra_out",
                                "#main/graph_inheritance/svg"
                            ],
                            "linkMerge": "merge_flattened",
                            "valueFrom": "$(self.slice(1))",
                            "id": "#main/merge/secondary"
                        }
                    ],
                    "out": [
                        "#main/merge/dir"
                    ],
                    "run": "#mergesecondary.cwl",
                    "id": "#main/merge"
                }
            ],
            "id": "#main",
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/merge/dir",
                    "id": "#main/doc_out"
                },
                {
                    "type": "File",
                    "outputSource": "#main/generate_report/report",
                    "id": "#main/report"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#inheritance.cwl/schema"
                },
                {
                    "type": "string",
                    "id": "#inheritance.cwl/target_path"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#inheritance.cwl/svg",
                    "outputBinding": {
                        "glob": "$(inputs.target_path)"
                    }
                },
                {
                    "type": "string",
                    "outputBinding": {
                        "outputEval": "$(inputs.target_path.match(/^([^/]+)\\/[^/]/)[1])"
                    },
                    "id": "#inheritance.cwl/targetdir"
                }
            ],
            "stdout": "$(inputs.target_path)",
            "baseCommand": "schema-salad-tool",
            "arguments": [
                "--print-inheritance-dot",
                "$(inputs.schema)",
                {
                    "valueFrom": "|",
                    "shellQuote": false
                },
                "dot",
                "-Tsvg"
            ],
            "id": "#inheritance.cwl"
        },
        {
            "class": "CommandLineTool",
            "hints": [
                {
                    "dockerFile": "FROM debian:8\nRUN apt-get update && \\\n    DEBIAN_FRONTEND=noninteractive apt-get -yq install w3c-linkchecker \\\n",
                    "dockerImageId": "commonworkflowlanguage/checklink",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#linkchecker.cwl/inp"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "linkchecker-report.txt"
                    },
                    "id": "#linkchecker.cwl/report"
                }
            ],
            "baseCommand": "checklink",
            "arguments": [
                "-X(http.*|mailto:.*)",
                "-q"
            ],
            "stdout": "linkchecker-report.txt",
            "id": "#linkchecker.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#makecontext.cwl/schema"
                },
                {
                    "type": "string",
                    "id": "#makecontext.cwl/target_path"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#makecontext.cwl/jsonld_context",
                    "outputBinding": {
                        "glob": "$(inputs.target_path)"
                    }
                },
                {
                    "type": "string",
                    "outputBinding": {
                        "outputEval": "$(inputs.target_path.match(/^([^/]+)\\/[^/]/)[1])"
                    },
                    "id": "#makecontext.cwl/targetdir"
                }
            ],
            "baseCommand": [
                "python",
                "-mschema_salad",
                "--print-jsonld-context"
            ],
            "stdout": "$(inputs.target_path)",
            "id": "#makecontext.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "expressionLib": [
                        "var cwl = { path: {} };\n\ncwl.path.split = function(p) {\n    i = p.lastIndexOf('/') + 1;\n    var head = p.slice(0, i);\n    var tail = p.slice(i);\n    var rep = \"\";\n    for (var i = 0; i < head.length; i++) {\n        rep += \"/\";\n    }\n    if (head && head != rep) {\n        while (head[head.length-1] == \"/\") {\n            head = p.slice(0, head.length-1);\n        }\n    }\n    return [head, tail]\n};\n\ncwl.path.dirname = function(path) {\n    return cwl.path.split(path)[0];\n};\n\ncwl.path.basename = function(path) {\n    return cwl.path.split(path)[1];\n};\n\ncwl.path.isabs = function(s) {\n    return (s[0] == '/');\n}\n\n/* TODO: finish porting from Python\n\ncwl.path.splitext = function(p) {\n    var sep = \"/\";\n    var extsep = \".\";\n    var sepIndex = p.rfind(sep);\n    var dotIndex = p.rfind(extsep);\n    if (dotIndex > sepIndex) {\n        // skip all leading dots\n        filenameIndex = sepIndex + 1;\n        while (filenameIndex < dotIndex) {\n            if (p[filenameIndex] != extsep) {\n                return p[:dotIndex], p[dotIndex:]\n            }\n            filenameIndex += 1;\n        }\n    }\n    return p, ''\n};\n\n\ncwl.path.join = function(a) {\n    for (b in p) {\n        if (b.startswith('/')) {\n            path = b;\n        }\n        else if (path == '' or path.endswith('/')) {\n            path +=  b;\n        } else {\n            path += '/' + b;\n        }\n    }\n    return path;\n}\n\ncwl.path.relpath = function(path, start) {\n    if not path:\n        raise ValueError(\"no path specified\")\n\n    start_list = [x for x in abspath(start).split(sep) if x]\n    path_list = [x for x in abspath(path).split(sep) if x]\n\n    # Work out how much of the filepath is shared by start and path.\n    i = len(commonprefix([start_list, path_list]))\n\n    rel_list = [pardir] * (len(start_list)-i) + path_list[i:]\n    if not rel_list:\n        return curdir\n    return join(*rel_list)\n}\n\ncwl.path.normpath = function(path) {\n    slash, dot = (u'/', u'.') if isinstance(path, _unicode) else ('/', '.')\n    if path == '':\n        return dot\n    initial_slashes = path.startswith('/')\n    # POSIX allows one or two initial slashes, but treats three or more\n    # as single slash.\n    if (initial_slashes and\n        path.startswith('//') and not path.startswith('///')):\n        initial_slashes = 2\n    comps = path.split('/')\n    new_comps = []\n    for comp in comps:\n        if comp in ('', '.'):\n            continue\n        if (comp != '..' or (not initial_slashes and not new_comps) or\n             (new_comps and new_comps[-1] == '..')):\n            new_comps.append(comp)\n        elif new_comps:\n            new_comps.pop()\n    comps = new_comps\n    path = slash.join(comps)\n    if initial_slashes:\n        path = slash*initial_slashes + path\n    return path or dot\n\n}\n*/\n"
                    ],
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--brand"
                    },
                    "id": "#makedoc.cwl/brand"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--brandlink"
                    },
                    "id": "#makedoc.cwl/brandlink"
                },
                {
                    "type": "File",
                    "id": "#makedoc.cwl/extra"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--primtype"
                    },
                    "id": "#makedoc.cwl/primtype"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string",
                            "inputBinding": {
                                "prefix": "--redirect"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#makedoc.cwl/redirect"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string",
                            "inputBinding": {
                                "prefix": "--only"
                            }
                        }
                    ],
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#makedoc.cwl/renderlist"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#makedoc.cwl/source"
                },
                {
                    "type": "string",
                    "id": "#makedoc.cwl/target"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "outputEval": "$(inputs.extra)"
                    },
                    "id": "#makedoc.cwl/extra_out"
                },
                {
                    "type": "File",
                    "id": "#makedoc.cwl/html",
                    "outputBinding": {
                        "glob": "$(inputs.target)"
                    }
                },
                {
                    "type": "string",
                    "outputBinding": {
                        "outputEval": "${\n  var m = inputs.target.match(/^([^/]+)\\/[^/]/);\n  if (m)\n    return m[1];\n  else\n    return \"\";\n}\n"
                    },
                    "id": "#makedoc.cwl/targetdir"
                }
            ],
            "baseCommand": "schema-salad-doc",
            "stdout": "$(inputs.target)",
            "id": "#makedoc.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#makerdfs.cwl/schema"
                },
                {
                    "type": "string",
                    "id": "#makerdfs.cwl/target_path"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#makerdfs.cwl/rdfs",
                    "outputBinding": {
                        "glob": "$(inputs.target_path)"
                    }
                },
                {
                    "type": "string",
                    "outputBinding": {
                        "outputEval": "$(inputs.target_path.match(/^([^/]+)\\/[^/]/)[1])"
                    },
                    "id": "#makerdfs.cwl/targetdir"
                }
            ],
            "baseCommand": [
                "python",
                "-mschema_salad",
                "--print-rdfs"
            ],
            "stdout": "$(inputs.target_path)",
            "id": "#makerdfs.cwl"
        },
        {
            "class": "ExpressionTool",
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#mergesecondary.cwl/dirs"
                },
                {
                    "type": "File",
                    "id": "#mergesecondary.cwl/primary"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#mergesecondary.cwl/secondary"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#mergesecondary.cwl/dir"
                }
            ],
            "expression": "${\n  inputs.primary.secondaryFiles = [];\n  for (var i = 0; i < inputs.secondary.length; i++) {\n    var k = inputs.secondary[i];\n    if (inputs.dirs[i] != \"\") {\n      inputs.primary.secondaryFiles.push({\n          class: \"Directory\",\n          basename: inputs.dirs[i],\n          listing: [k]\n      });\n    } else {\n      inputs.primary.secondaryFiles.push(k);\n    }\n  }\n  return {dir: inputs.primary};\n}\n",
            "id": "#mergesecondary.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
